-- name: [CS] Rose Lalonde
-- description: Your name is ROSE. As was previously mentioned you are without ELECTRICITY, although your LAPTOP COMPUTER still functions on BATTERY POWER. You have a variety of INTERESTS. You have a passion for RATHER OBSCURE LITERATURE. You enjoy creative writing and are SOMEWHAT SECRETIVE ABOUT IT. You have a fondness for the BESTIALLY STRANGE AND FICTITIOUS, and sometimes dabble in PSYCHOANALYSIS. You also like to KNIT, and your room is a BIT OF A MESS. And on occasion, if just the right one strikes your fancy, you like to play VIDEO GAMES with your friends.
--[[API Documentation for Character Select can be found below:
https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation]]

--- MODEL ---
local E_MODEL_ROSE = smlua_model_util_get_id("rose_geo")
local E_MODEL_ROSESQUIDDLE = smlua_model_util_get_id("rosesquiddle_geo")
local E_MODEL_ROSETROLL = smlua_model_util_get_id("rosetroll_geo")
local E_MODEL_ROSEBLACK = smlua_model_util_get_id("roseblack_geo")
local E_MODEL_ROSEGRIMDARK = smlua_model_util_get_id("rosegrimdark_geo")
local E_MODEL_ROSEGODTIER = smlua_model_util_get_id("rosegodtier_geo")
local E_MODEL_ROSE_CAP = smlua_model_util_get_id("defaultrose_cap_geo")
local E_MODEL_ROSE_CAP = smlua_model_util_get_id("squiddlerose_cap_geo")
local E_MODEL_ROSE_CAP = smlua_model_util_get_id("blackrose_cap_geo")
local E_MODEL_ROSE_CAP = smlua_model_util_get_id("godtierrose_cap_geo")
local E_MODEL_ROSE_CAP = smlua_model_util_get_id("trollrose_cap_geo")
local E_MODEL_ROSE_METAL = smlua_model_util_get_id("rose_metalcap_geo")
local E_MODEL_ROSE_WING = smlua_model_util_get_id("defaultrose_wingcap_geo")
local E_MODEL_ROSE_WING = smlua_model_util_get_id("squiddlerose_wingcap_geo")
local E_MODEL_ROSE_WING = smlua_model_util_get_id("trollrose_wingcap_geo")
local E_MODEL_ROSE_WING = smlua_model_util_get_id("blackrose_wingcap_geo")

--- ICON ---
local TEX_ICON_ROSE = get_texture_info("rose-icon")
local TEX_ICON_ROSESQUIDDLE = get_texture_info("rose-squiddle-icon")
local TEX_ICON_ROSETROLL = get_texture_info("rose-troll-icon")
local TEX_ICON_ROSEBLACK = get_texture_info("rose-black-icon")
local TEX_ICON_ROSEGRIMDARK = get_texture_info("rose-grimdark-icon")
local TEX_ICON_ROSEGODTIER = get_texture_info("rose-godtier-icon")

local falling_sounds = {}
for i = 1, 9 do
    falling_sounds[i] = 'RoseFalling.ogg' 
end
for i = 10, 13 do
    falling_sounds[i] = 'RoseFallingRare.ogg' 
end

--[[
local falling_sounds = {}
for i = 1, 412 do
    falling_sounds[i] = 'RoseFalling.ogg'
end
falling_sounds[413] = 'RoseFallingRare.ogg'
]]


--- VOICE ---
local CUSTOM_VOICETABLE_ROSE = {
    [CHAR_SOUND_OKEY_DOKEY] =        'RoseStartGame.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] =         'RoseStartLevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] =         'RosePunch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] =         'RosePunch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] =         'RosePunch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] =       {'RoseJump1.ogg', 'RoseJump2.ogg', 'RoseJump3.ogg'}, -- First Jump Sounds
	[CHAR_SOUND_HOOHOO] =            'RoseDoubleJump.ogg', -- Second jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'RoseTripleJump1.ogg', 'RoseTripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] =                'RoseBonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] =               'RoseLongJumpLand.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] =             'RoseLongJumpLand2.ogg',
	[CHAR_SOUND_HAHA] =              'RoseTripleJumpLand.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] =             'RoseLongJump.ogg', -- Long jump
	[CHAR_SOUND_DOH] =               'RoseLongJumpBonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] =              'RoseGrabLedge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] =              'RoseClimbLedge.ogg', -- Climbing over ledge
    [CHAR_SOUND_WAAAOOOW] =          falling_sounds,
    [CHAR_SOUND_TWIRL_BOUNCE] =      'RoseFlowerBounce.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] =  'RoseGroundPound.ogg', 
	[CHAR_SOUND_HRMM] =              'RoseLift.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] =        'RoseGetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] =   'RoseThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'RoseDamaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'RosePanting.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'RoseBurned.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'RoseTired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'RoseYawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'RoseSnore.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'RoseExhale.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'RoseSleepTalk.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'RoseCough1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'RoseCough2.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'RoseCough3.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'RoseDying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'RoseDrowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'RoseLeaveLevel.ogg' -- Booted out of level
}

--- CHARACTER ---
if _G.charSelectExists then
    -- Add the main character
    local rose_id = _G.charSelect.character_add(
        "Rose Lalonde",
        {"flighty broad", " "},
        "TheEnderDwonk",
        {r = 181, g = 54, b = 218},
        E_MODEL_ROSE,
        CT_MARIO,
        TEX_ICON_ROSE
    )

	local capRoseDefault = {
    normal = smlua_model_util_get_id("defaultrose_cap_geo"),
    wing = smlua_model_util_get_id("defaultrose_wingcap_geo"),
	metal = smlua_model_util_get_id("rose_metalcap_geo")
}

	local capRoseSquiddle = {
    normal = smlua_model_util_get_id("squiddlerose_cap_geo"),
    wing = smlua_model_util_get_id("squiddlerose_wingcap_geo"),
	metal = smlua_model_util_get_id("rose_metalcap_geo")
}

	local capRoseTroll = {
    normal = smlua_model_util_get_id("trollrose_cap_geo"),
    wing = smlua_model_util_get_id("trollrose_wingcap_geo"),
	metal = smlua_model_util_get_id("rose_metalcap_geo")
}

	local capRoseBlack = {
    normal = smlua_model_util_get_id("blackrose_cap_geo"),
    wing = smlua_model_util_get_id("blackrose_wingcap_geo"),
	metal = smlua_model_util_get_id("rose_metalcap_geo")
}

	local capRoseGodtier = {
    normal = smlua_model_util_get_id("godtierrose_cap_geo"),
    wing = smlua_model_util_get_id("godtierrose_cap_geo"),
	metal = smlua_model_util_get_id("rose_metalcap_geo")
}

_G.charSelect.character_add_caps(E_MODEL_ROSE, capRoseDefault)
_G.charSelect.character_add_caps(E_MODEL_ROSESQUIDDLE, capRoseSquiddle)
_G.charSelect.character_add_caps(E_MODEL_ROSETROLL, capRoseTroll)
_G.charSelect.character_add_caps(E_MODEL_ROSEBLACK, capRoseBlack)
_G.charSelect.character_add_caps(E_MODEL_ROSEGRIMDARK, capRoseBlack)
_G.charSelect.character_add_caps(E_MODEL_ROSEGODTIER, capRoseGodtier)

  _G.charSelect.character_add_costume(
        rose_id,
        "Rose (Squiddleknit)",
        {"Quite stylish.", " "},
        "TheEnderDwonk",
        {r = 181, g = 54, b = 218},
        E_MODEL_ROSESQUIDDLE,
        CT_MARIO,
        TEX_ICON_ROSESQUIDDLE
    )

  _G.charSelect.character_add_costume(
        rose_id,
        "Troll Rose",
        {"How whelming. Horns. Skin as gray as concrete!", " "},
        "TheEnderDwonk",
        {r = 181, g = 54, b = 218},
        E_MODEL_ROSETROLL,
        CT_MARIO,
        TEX_ICON_ROSETROLL
    )	
	
  _G.charSelect.character_add_costume(
        rose_id,
        "Rose (Black Dress)",
        {"Perfect for stomping turtles.", " "},
        "TheEnderDwonk",
        {r = 181, g = 54, b = 218},
        E_MODEL_ROSEBLACK,
        CT_MARIO,
        TEX_ICON_ROSEBLACK
    )	
	
  _G.charSelect.character_add_costume(
        rose_id,
        "Grimdark Rose",
        {"I told her about stares.", " "},
        "TheEnderDwonk",
        {r = 181, g = 54, b = 218},
        E_MODEL_ROSEGRIMDARK,
        CT_MARIO,
        TEX_ICON_ROSEGRIMDARK
    )	
	
  _G.charSelect.character_add_costume(
        rose_id,
        "Rose (God Tier)",
        {"Her sun isn't green.", " "},
        "TheEnderDwonk",
        {r = 181, g = 54, b = 218},
        E_MODEL_ROSEGODTIER,
        CT_MARIO,
        TEX_ICON_ROSEGODTIER
    )		
	
    -- Add custom voice
    _G.charSelect.character_add_voice(E_MODEL_ROSE, CUSTOM_VOICETABLE_ROSE)
    _G.charSelect.character_add_voice(E_MODEL_ROSESQUIDDLE, CUSTOM_VOICETABLE_ROSE)	
    _G.charSelect.character_add_voice(E_MODEL_ROSETROLL, CUSTOM_VOICETABLE_ROSE)		
    _G.charSelect.character_add_voice(E_MODEL_ROSEBLACK, CUSTOM_VOICETABLE_ROSE)	
    _G.charSelect.character_add_voice(E_MODEL_ROSEGRIMDARK, CUSTOM_VOICETABLE_ROSE)
	_G.charSelect.character_add_voice(E_MODEL_ROSEGODTIER, CUSTOM_VOICETABLE_ROSE)

    -- Hook events for the character's custom behavior
    hook_event(HOOK_CHARACTER_SOUND, function(m, sound)
        if _G.charSelect.character_get_voice(m) == CUSTOM_VOICETABLE_ROSE then
            return _G.charSelect.voice.sound(m, sound)
        end
    end)

    hook_event(HOOK_MARIO_UPDATE, function(m)
        if _G.charSelect.character_get_voice(m) == CUSTOM_VOICETABLE_ROSE then
            return _G.charSelect.voice.snore(m)
        end
    end)
end
